<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Objects in JavaScript</title>
</head>
<body>
    <button>Kliki mind!</button>
    <script>
        // Object literal approach
        let myObj1 = {
            name: "Bruno",
            city: "Tallinn"
        };

        console.log(`Inimene nimega ${myObj1.name} elab kohas ${myObj1.city}`);

        // new object() approach
        let myObj2 = new Object();
        myObj2.name = "Lennart";
        myObj2.city = "Tartu";

        console.log(`Inimene nimega ${myObj2.name} elab kohas ${myObj2.city}`);

        // ECMAScript 6 (2015)
        class Person {
            constructor(name, city) {
                this.name = name;
                this.city = city;
            }
        }

        let myObj3 = new Person("Teet", "Pärnu");

        console.log(`Inimene nimega ${myObj3.name} elab kohas ${myObj3.city}`);

        // 'this' context issue
        class MyTest {
            constructor() {
                // this.myClassicFunc = this.myClassicFunc.bind(this);
                let button = document.querySelector('button');
                button.addEventListener('click', this.myClassicFunc);
                button.addEventListener('click', this.myArrowFunc);
            }

            myClassicFunc() {
                console.log("myClassiFunc", this);
            }

            myArrowFunc = () => console.log("myArrowFunc", this);
        }

        let myTestObj = new MyTest();

    </script>
</body>
</html>